package com.edufound.mobile.wxapi;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Message;

import com.google.gson.Gson;
import com.tencent.mm.opensdk.constants.ConstantsAPI;
import com.tencent.mm.opensdk.modelbase.BaseReq;
import com.tencent.mm.opensdk.modelbase.BaseResp;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.IWXAPIEventHandler;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;

import org.cocos2dx.javascript.presenter.MainPresenter;
import org.cocos2dx.javascript.util.Logger;

import java.util.HashMap;
import java.util.Map;

public class WXPayEntryActivity extends Activity implements IWXAPIEventHandler {

    private static final String TAG = WXPayEntryActivity.class.getSimpleName();

    private IWXAPI api;
    Gson mGson;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        api = WXAPIFactory.createWXAPI(this, MainPresenter.WX_APPID);
        api.handleIntent(getIntent(), this);
        mGson = new Gson();

    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        setIntent(intent);
        api.handleIntent(intent, this);
    }

    @Override
    public void onReq(BaseReq baseReq) {
        Logger.e("onReq-onReq--onReq--onReq--onReq");
    }

    @Override
    public void onResp(BaseResp baseResp) {
        if (baseResp.getType() == ConstantsAPI.COMMAND_PAY_BY_WX) {
            if (baseResp.errCode == 0) {// 支付成功
//                CustomToast.showToast(this, "支付成功", 3000);
                Logger.e("支付成功");
            } else if (baseResp.errCode == -2) {// 用户取消支付
//                CustomToast.showToast(this, "支付已取消", 3000);
                Logger.e("用户取消支付");
            } else {// 支付失败
                Logger.e("支付失败");
//                CustomToast.showToast(this, "支付失败:" + baseResp.errCode + "--:baseResp.errStr" + baseResp.errStr, 3000);
            }
            payBack bean = new payBack(baseResp.errCode, baseResp.errStr != null ? baseResp.errStr : "", baseResp.transaction != null ? baseResp.transaction : "", baseResp.openId != null ? baseResp.openId : "");
            Message msg = new Message();
            msg.what = 0xffbcd13;
            msg.obj = bean;
            MainPresenter.resultHandler.sendMessage(msg);
            Logger.e("关闭界面！");

        }
        finish();
    }

    public class payBack {
        public int errorCode;
        public String errStr;
        public String transaction;
        public String openId;

        payBack(int errorCode, String errStr, String transaction, String openId) {
            this.errorCode = errorCode;
            this.errStr = errStr;
            this.transaction = transaction;
            this.openId = openId;
        }
    }
}